#include <queue>
#include <cstdio>
#include <fstream>
#include <cstdlib>
#include <vector>
#include <cmath>
#define impH 7 // importancia hornatosti
#define impZ 1 // imp. produkcie
#define impV 5 // imp. nepriatelskej obrany
#define risk 1.4 // nakolko pri utoku riskujeme
#define impX 1 // nakolko chceme prvi brat neutralnu krajinu
#define impY 1 // hocijaku krajinu
using namespace std;

extern void wPrihlasenie(const char*);
extern int wMojeID();

extern int wPocetKrajin();
extern int wPocetMojichKrajin();
extern int wDalsiaMojaKrajina();

extern int wPeniaze();
extern int wSusedia(int krajinaA, int krajinaB);

extern int wHornatost(int krajina);
extern int wProsperita(int krajina);
extern int wMajitel(int krajina);
extern int wVojsko(int krajina);

extern bool wNajmi(int kde, int kolko);
extern void wNeutoc();
extern bool wZautoc(int odkial, int kam, int kolko);

extern bool wSuNovinky();
extern int wDalsiaNovinka();

int main() {
//fork();
//papek();
//printf("trololo\n");

wPrihlasenie("This is Pascal!");

fstream d;
d.open("debug",fstream::out|fstream::trunc);

vector< vector<bool> > sus(wPocetKrajin()); // zoznam susednosti
for(int i =0; i < wPocetKrajin(); i++) for(int j =0; j < wPocetKrajin(); j++) if(i != j && wSusedia(i+1,j+1)) sus[i].push_back(j);

while(true) {
	int odkial =0,kam =0;
	double koefMax =0.0;
	int minV =10000000,dvaminV =1000000;
	for(int i =0; i < wPocetKrajin(); i++) if(wVojsko(i+1) > 0) minV =min(minV,wVojsko(i+1));
	for(int i =0; i < wPocetKrajin(); i++) if(wVojsko(i+1) > minV) dvaminV =min(dvaminV,wVojsko(i+1));
	for(int i =0; i < wPocetKrajin(); i++) if(wVojsko(i+1) == minV) wNajmi(i+1,min(dvaminV-minV,wPeniaze()));
	for(int i =0; i < wPocetKrajin(); i++) for(int j =0; j < wPocetKrajin(); j++) 
		if(i != j && wSusedia(i+1,j+1) && wMajitel(i+1) == wMojeID() && wMajitel(j+1) != wMojeID()) {
			// zrataj koeficient
			double koef =1.0;
			if(pow(1.25,wHornatost(j+1))*wVojsko(j+1)*risk >= (wVojsko(i+1)+wPeniaze())) koef =0.0;
			for(int k =0; k < impV; k++) {
				if(wVojsko(j+1) == 0) koef =100000.0;
				else koef /=wVojsko(j+1);}
			for(int k =0; k < impH; k++) koef /=pow(1.25,wHornatost(j+1));
			for(int k =0; k < impZ; k++) koef *=pow(1.25,wProsperita(j+1));
			int pocetN =1,pocetC =1;
			for(int k =0; k < wPocetKrajin(); k++) {
				if(wMajitel(k+1) == wMojeID() && wSusedia(k+1,kam+1)) pocetN++;
				if(wMajitel(k+1) != wMojeID() && wMajitel(k+1) >= 1 && wSusedia(k+1,kam+1)) pocetC++;}
			for(int k =0; k < impX; k++) koef *=(double)pocetN;
			for(int k =0; k < impX; k++) {
				if(pocetC > 0) koef /=(double)pocetC;
				else koef *=300;}
			pocetN =1,pocetC =1;
			for(int k =0; k < wPocetKrajin(); k++) {
				if(wMajitel(k+1) == wMojeID() && wSusedia(k+1,kam+1)) pocetN++;
				if(wMajitel(k+1) != wMojeID() && wMajitel(k+1) >= 0 && wSusedia(k+1,kam+1)) pocetC++;}
			for(int k =0; k < impY; k++) koef *=(double)pocetN;
			for(int k =0; k < impY; k++) {
				if(pocetC > 0) koef /=(double)pocetC;
				else koef *=300;}
			d << pocetN << " " << pocetC << endl;
			d << koef << " " << i << " " << j << endl;
			if(koef > koefMax) {odkial =i; kam =j; koefMax =koef;}
			if(koefMax == 0) odkial =i;}
	int odkialP =0,kamP =0;
	for(int i =0; i < wPocetKrajin(); i++) for(int j =0; j < wPocetKrajin(); j++) 
		if(i != j && wSusedia(i+1,j+1) && wMajitel(i+1) == wMojeID() && wMajitel(j+1) == wMojeID()) {
			bool ok =true;
			for(int k =0; k < wPocetKrajin(); k++) if(wSusedia(i+1,k+1) && wMajitel(k+1) == wMojeID()) ok =false;
			if(!ok) continue;
			for(int k =0; k < wPocetKrajin(); k++) if(wSusedia(j+1,k+1) && wMajitel(k+1) != wMojeID()) ok =false;
			if(!ok) {kamP =i; odkialP =j; break;}}
	vector<int> smer;
	vector<int> dist;
	for(int i =0; i < wPocetKrajin(); i++) {
		smer.push_back(0);
		dist.push_back(-1);}
	queue<int> nodes;
	nodes.push(odkialP);
	dist[odkial] =0;
	while(!nodes.empty()) {
		for(int i =0; i < wPocetKrajin(); i++) if(wSusedia(nodes.front()+1,i+1) && dist[i] == -1) {
			dist[i] =dist[nodes.front()]+1;
			smer[i] =nodes.front();
			nodes.push(i);}
		nodes.pop();}
	if(kamP != odkialP) {
		wNajmi(odkialP+1,wPeniaze());
		wZautoc(kamP+1,odkialP+1,wVojsko(kam+1));}
	if(koefMax <= 0.00000000001) {
		d << kam << odkial << endl;
		wNajmi(odkial+1,wPeniaze());
		wNeutoc();}
	d << kam << odkial << endl;
	wNajmi(odkial+1,wPeniaze());
	int utocV =wVojsko(odkial+1);
	for(int i =0; i < wPocetKrajin(); i++) if(wSusedia(i+1,odkial+1) && i != odkial && wMajitel(i+1) != wMojeID() && i != kam) utocV =(wVojsko(odkial+1)/10)*7;
	wZautoc(odkial+1,kam+1,utocV);}
return 0;}
