/**************************************/
/*      PROBOJ KSP JESEN 2011         */
/*         VEDUCOVSKY HRAC            */
/**************************************/

#include <cstdio>
#include <cstdlib>
#include <ctime>

extern void wPrihlasenie(const char*);
extern int wMojeID();

extern int wPocetKrajin();
extern int wPocetMojichKrajin();
extern int wDalsiaMojaKrajina();

extern int wPeniaze();
extern int wSusedia(int krajinaA, int krajinaB);

extern int wHornatost(int krajina);
extern int wProsperita(int krajina);
extern int wMajitel(int krajina);
extern int wVojsko(int krajina);

extern bool wNajmi(int kde, int kolko);
extern void wNeutoc();
extern bool wZautoc(int odkial, int kam, int kolko);

extern bool wSuNovinky();
extern int wDalsiaNovinka();

int main() {
    wPrihlasenie("Orakulum");
    
    while (1) {
	int x = 1, y = 2;
	for (int i = 1; i <= wPocetKrajin(); i++)
		for (int j = 1; j <= wPocetKrajin(); j++)
			if (i != j && wSusedia(i, j) && wMajitel(i) == wMojeID() &&
			    wMajitel(j) != wMojeID()) {
				x = i;
				y = j;
			    }

	wNajmi(x, wPeniaze());
	wZautoc(x, y, 1);
    }
}
